<?php 

function replaceObjEmbed($x,$jsdirprefix="pc_inc") {

  $tags=array('`<object[^>]*>(.*)</object>`isU', # <object ...>...</object> areas
              '`<applet[^>]*>(.*)</applet>`isU', # <applet ...>...</applet> areas
              '`<embed[^>]*>(.*)</embed>`isU',   # <embed ...>..</embed> areas
              '`<embed[^>]*>`isU');              # single, unclosed <embed ...> tags outsite object areas

  $replacements=array(); # Storage for the elements found to be processed

  foreach(array_keys($tags) as $idx) { # Handle all kings of tag areas and tags, one by one

    $tmptags=array(); # Storage for the found occurrences
    preg_match_all($tags[$idx],$x,$tmptags); # And here they are

    if ($tmptags) { # Found some?

      foreach(array_keys($tmptags[0]) as $secidx) { # Deal with them, one by one

        # We have to move them apart -- especially <object ...>...</object> areas with an internal
        # <embed ...>..</embed> area or an unclosed <embed ...> tag -- otherwise they'd be found again.

        $tagval=$tmptags[0][$secidx]; # This is the current occurrence to be processed later on
        $tagkey="replacetag_".$idx."_".$secidx; # Temporarily replace it by "replacetag_x_y"
        # ... where x is 0..3 (object/applet/embed/s.embed) and y is the corresponding number.

        $replacements[$tagkey]=$tagval; # Store the occurrence beside it's unique key ...
        $x=str_replace($tagval,$tagkey,$x); # ... and actually replace the occurrence with the key
      }
    }

    unset($tmptags); # A bit of dirty work

  }

  foreach($replacements as $tagkey => $tagval) { # Handle all occurrences, one by one

    $jsval=addslashes($tagval); # Handle special characters properly
    $jsval=str_replace(chr(13),"",$jsval); # remove CRs - all in one line
    $jsval=str_replace(chr(10),"",$jsval); # remove LFs - all in one line

    $jsval= "<script src=\"js/replaceObjEmbed.js\" type=\"text/javascript\"></script>\n".
            "<script language=\"JavaScript\">\n".
            "<!--\n".
            "var jsval = '$jsval';\n".
#           "//document.write(jsval);". # This doesn't work as it's an internal document.write(...)
            "writethis(jsval);". # So: Use the external one-liner function to perform the trick
            "//-->\n".
            "</script>\n".
            "<noscript>$tagval</noscript>";

    # The original occurrence has been replaced with its unique "key" beforehanded,
		# now replace this stored key with is JS wrapper and noscript fallback.
    $x=str_replace($tagkey,$jsval,$x);

  }

  unset($replacements); # A bit of dirty work

  return $x; # And we're out!
}
?>
